OBJS     =  inc.tcl.c inc.utils.c inc.crypt.c config.h inc.uuencode.c
PKG_LIB_FILE	= libnsmcrypt1.1.so
PKG_OBJECTS	= nsmcrypt.o
INSTALL_DIR = /usr/lib/nsmcrypt1.1
CLEANFILES	= pkgIndex.tcl

CC		= gcc -pipe 
CFLAGS_DEFAULT	= -O
CFLAGS_WARNING	= -Wall -Wconversion -Wno-implicit-int
EXEEXT		= 
LDFLAGS_DEFAULT	= -rdynamic
MAKE_LIB	= ${SHLIB_LD} -o $@ $(PKG_OBJECTS) ${SHLIB_LD_FLAGS} ${SHLIB_LD_LIBS} 
OBJEXT		= o
SHLIB_CFLAGS	= -fPIC
SHLIB_LD	= gcc -pipe -shared
SHLIB_LD_FLAGS	= 
SHLIB_LD_LIBS	= ${LIBS}  -ltclstub8.4 -lmcrypt
STLIB_LD	= ${AR} cr
TCL_DEFS	=  -DHAVE_LIMITS_H=1 -DHAVE_UNISTD_H=1 -DHAVE_SYS_PARAM_H=1 -DUSE_THREAD_ALLOC=1 -D_REENTRANT=1 -D_THREAD_SAFE=1 -DHAVE_PTHREAD_ATTR_SETSTACKSIZE=1 -DHAVE_PTHREAD_ATFORK=1 -DTCL_THREADS=1 -DPEEK_XCLOSEIM=1 -D_LARGEFILE64_SOURCE=1 -DTCL_WIDE_INT_TYPE=long\ long -DHAVE_STRUCT_STAT64=1 -DHAVE_OPEN64=1 -DHAVE_LSEEK64=1 -DHAVE_TYPE_OFF64_T=1 -DHAVE_GETCWD=1 -DHAVE_OPENDIR=1 -DHAVE_STRSTR=1 -DHAVE_STRTOL=1 -DHAVE_STRTOLL=1 -DHAVE_STRTOULL=1 -DHAVE_TMPNAM=1 -DHAVE_WAITPID=1 -DHAVE_GETPWUID_R_5=1 -DHAVE_GETPWUID_R=1 -DHAVE_GETPWNAM_R_5=1 -DHAVE_GETPWNAM_R=1 -DHAVE_GETGRGID_R_5=1 -DHAVE_GETGRGID_R=1 -DHAVE_GETGRNAM_R_5=1 -DHAVE_GETGRNAM_R=1 -DHAVE_GETHOSTBYNAME_R_6=1 -DHAVE_GETHOSTBYNAME_R=1 -DHAVE_GETHOSTBYADDR_R_8=1 -DHAVE_GETHOSTBYADDR_R=1 -DUSE_TERMIOS=1 -DHAVE_SYS_TIME_H=1 -DTIME_WITH_SYS_TIME=1 -DHAVE_TM_ZONE=1 -DHAVE_GMTIME_R=1 -DHAVE_LOCALTIME_R=1 -DHAVE_TM_GMTOFF=1 -DHAVE_TIMEZONE_VAR=1 -DHAVE_ST_BLKSIZE=1 -DSTDC_HEADERS=1 -DHAVE_SIGNED_CHAR=1 -DHAVE_LANGINFO=1 -DHAVE_SYS_IOCTL_H=1 
TCL_LIBS	= ${DL_LIBS} ${LIBS} ${MATH_LIBS}

DEFS		=  ${TCL_DEFS} -DSTDC_HEADERS=1 -DHAVE_SYS_TYPES_H=1 -DHAVE_SYS_STAT_H=1 -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_MEMORY_H=1 -DHAVE_STRINGS_H=1 -DHAVE_INTTYPES_H=1 -DHAVE_STDINT_H=1 -DHAVE_UNISTD_H=1 -D_LARGEFILE64_SOURCE=1 -DTCL_WIDE_INT_TYPE=long\ long -DHAVE_STRUCT_STAT64=1 -DHAVE_TYPE_OFF64_T=1 -DHAVE_LIMITS_H=1 -DHAVE_UNISTD_H=1 -DHAVE_SYS_PARAM_H=1 -DUSE_TCL_STUBS=1  -DNO_AOLSERVER=1


CPPFLAGS	=  ${SHLIB_CFLAGS}
LIBS		=  
AR		= ar
CFLAGS		=
COMPILE		= $(CC) $(DEFS) $(INCLUDES)  $(CPPFLAGS)  $(CFLAGS)

all: $(PKG_LIB_FILE)

$(PKG_OBJECTS): $(OBJS)

$(PKG_LIB_FILE): $(PKG_OBJECTS)
	-rm -f $(PKG_LIB_FILE)
	${MAKE_LIB}


.c.o:
	$(COMPILE) -c `echo $<` -o $@


install:
	mkdir $(INSTALL_DIR)
	cp $(PKG_LIB_FILE) $(INSTALL_DIR)
	cp $(CLEANFILES) $(INSTALL_DIR)
