<html>
<head>
<title>Doc :: capatibility :: algorithm, mode, ...</title>
</head>
<body>
<a href="../index.adp">up</a><br>
<h1>Capability</h1>
<h2>Available algorithms</h2>
<table border="1">
<tr><td align="right">command:</td><td><tt><font color="navyblue">ns_mcrypt algorithms</font></tt></td></tr>
<tr><td align="right">result:</td><td>list of available cipher algorithms</td></tr>
<tr><td align="right">example:</td><td>[ns_mcrypt algorithms]=<%=[ns_mcrypt algorithms]%></td></tr>
</table>

<h2>Available modes</h2>
<table border="1">
<tr><td align="right">command:</td><td><tt><font color="navyblue">ns_mcrypt modes</font></tt></td></tr>
<tr><td align="right">result:</td><td>list of available cipher modes</td></tr>
<tr><td align="right">example:</td><td>[ns_mcrypt  modes]=<%=[ns_mcrypt  modes]%></td></tr>
</table>

<h2>algorithm capability</h2>
<table border="1">
<tr><td align="right">command:</td><td><tt><font color="navyblue">ns_mcrypt capability -algo <i>algorithm_name</i></font></tt></td></tr>
<tr><td align="right">parameters:</td><td><i>algorithm_name</i> - name of cipher algorithm: des, blowfish, rijndael-256, ... </td></tr>
<tr><td align="right">result:</td><td>list of capability for <i>algorithm_name</i></td></tr>
<tr><td align="right" valign="top">result description:</td>
<td>
&bull; 0. index of list ([lindex 0 $result]) - <font color="red">0</font> if ran self test on specified algorithm succeeds or <font color="red">1</font>.<br>
&bull; 1. index of list ([lindex 1 $result]) - <font color="red">1</font> if the specified algorithm is a block algorithm or <font color="red">0</font> if it is a stream algorithm.<br>
&bull; 2. index of list ([lindex 2 $result]) - <font color="red">The block size</font> of the specified algorithm.<br>
&bull; 3. index of list ([lindex 3 $result]) - Maximum supported <font color="red">key size</font> of the specified algorithm<br>
&bull; 4. index of list ([lindex 4 $result]) - <font color="red">Key sizes</font> supported by the specified algorithm.
If sizes is <font color="red">0</font> then all key sizes between <font color="red">1</font>
 and <font color="red">maximum key size</font> are supported by the algorithm.
  If it is <font color="red">1</font> then only the <font color="red">maximum key size</font> is supported.
  If it is greater than <font color="red">1</font> then that number specifies
  the number of elements in sizes which are the key sizes that the algorithm supports.<br>
&bull; 5. index of list ([lindex 5 $result]) - List of <font color="red">key sizes</font> that the algorithm supports or is not set.
See above.<br>
</td></tr>
<tr><td align="right">example:</td><td>[ns_mcrypt capability  -algo "rijndael-256"]=<%=[ns_mcrypt capability  -algo "rijndael-256"]%></td></tr>
</table>

<h2>mode capability</h2>
<table border="1">
<tr><td align="right">command:</td><td><tt><font color="navyblue">ns_mcrypt capability -mode <i>mode_name</i></font></tt></td></tr>
<tr><td align="right">parameters:</td><td><i>algorithm_name</i> - name of cipher algorithm: des, blowfish, rijndael-256, ... </td></tr>
<tr><td align="right">result:</td><td>list of capability for <i>algorithm_name</i></td></tr>
<tr><td align="right" valign="top">result description:</td>
<td>
&bull; 0. index of list ([lindex 0 $result]) - <font color="red">1</font> if the specified mode outputs blocks of bytes or <font color="red">0</font> if it outputs bytes. (eg. 1 for cbc and ecb, and 0 for cfb and stream).<br>
&bull; 1. index of list ([lindex 1 $result]) - <font color="red">1</font> if the specified mode is for use with block algorithms, otherwise it returns <font color="red">0</font>. (eg. 0 for stream, and 1 for cbc, cfb, ofb).<br>
</td></tr>
<tr><td align="right">example:</td><td>[ns_mcrypt capability  -mode "cbc"]=<%=[ns_mcrypt capability  -mode "cbc"]%></td></tr>
</table>


</body>
</html>
