<html>
<head>
<title>Doc :: cipher :: crypt, decrypt, ...</title>
</head>
<body>
<a href="../index.adp">up</a><br>
<h1>Cipher</h1>

<h2>create new MCRYPT object</h2>
<table border="1">
<tr><td align="right">command:</td><td><tt><font color="navyblue">ns_mcrypt new <i>algorithm_name</i> <i>mode_name</i></font></tt></td></tr>
<tr><td align="right">parameters:</td><td><i>algorithm_name</i> - name of cipher algorithm: des, blowfish, rijndael-256, ... <br>
<i>mode_name</i> - name of cipher mode: cbc, ncfb, stream, ...
</td></tr>
<tr><td align="right">result:</td><td>MCRYPT object using in other commands</td></tr>
<tr><td align="right">example:</td><td>set mcryptid [ns_mcrypt new "rijndael-256" "cbc"]</td></tr>
</table>

<h2>destroy MCRYPT object</h2>
<table border="1">
<tr><td align="right">command:</td><td><tt><font color="navyblue">ns_mcrypt destroy <i>mcrypt_id</i></font></tt></td></tr>
<tr><td align="right">parameters:</td><td><i>mcrypt_id</i> - id of MCRYPT object generated by new command (above) </td></tr>
<tr><td align="right">result:</td><td>destroy MCRYPT object - close loaded module, freeing IV</td></tr>
<tr><td align="right">example:</td><td>ns_mcrypt destroy $mcryptid</td></tr>
</table>

<h2>initialize MCRYPT object</h2>
<table border="1">
<tr><td align="right">command:</td><td><tt><font color="navyblue">ns_mcrypt init <i>mcrypt_id</i> <i>keyword</i></font></tt></td></tr>
<tr><td align="right">parameters:</td><td>
<i>mcrypt_id</i> - id of MCRYPT object generated by new command (above) <br>
<i>keyword</i> - keyword/password using in cipher process<br>
</td></tr>
<tr><td align="right">result:</td><td>initialize MCRYPT object with keyword</td></tr>
<tr><td align="right">example:</td><td>ns_mcrypt init $mcryptid "foo"</td></tr>
</table>


<h2>flushing/freeing MCRYPT object</h2>
<table border="1">
<tr><td align="right">command:</td><td><tt><font color="navyblue">ns_mcrypt flush <i>mcrypt_id</i></font></tt></td></tr>
<tr><td align="right">parameters:</td><td>
<i>mcrypt_id</i> - id of MCRYPT object generated by new command (above) <br>
</td></tr>
<tr><td align="right">result:</td><td>freeing internal buffer of MCRYPT object without changing of IV. MCRYPT object can be reusing in next process. IV is not change.</td></tr>
<tr><td align="right">example:</td><td>ns_mcrypt flush $mcryptid</td></tr>
</table>


<h2>crypt plaintext</h2>
<table border="1">
<tr><td align="right">command:</td><td><tt><font color="navyblue">ns_mcrypt crypt -in raw|hex|base64 -out raw|str|hex|base64 <i>mcrypt_id</i> <i>plain_text</i></font></tt></td></tr>
<tr><td align="right">parameters:</td><td>
-in raw|hex|base64 - type of input format for plaintext :: hexadecimal string: -hex; raw string (binary, plain) (TclByteArray): -raw; binary base64 encoded: -base64.<br />
-out raw|str|hex|base64 - type of output format for encrypted ciphertext :: hexadecimal string: -hex; raw string (binary) (TclByteArray): -raw; string (TclString): -str; binary base64 encoded: -base64.<br />
<i>mcrypt_id</i> - id of MCRYPT object generated by new command (above) <br>
<i>plain_text</i> - plaintext you wish to encrypt.<br>
</td></tr>
<tr><td align="right">result:</td><td>return ciphet text of <i>plain_text</i></td></tr>
<tr><td align="right">example:</td><td>set ctxt [ns_mcrypt crypt -in raw -out hex $mcryptid "foofoo"]</td></tr>
</table>

<h2>decrypt ciphertext</h2>
<table border="1">
<tr><td align="right">command:</td><td><tt><font color="navyblue">ns_mcrypt decrypt -in raw|hex|base64 -out raw|str|hex|base64 <i>mcrypt_id</i> <i>cipher_text</i></font></tt></td></tr>
<tr><td align="right">parameters:</td><td>
-in raw|hex|base64 - type of input format for ciphertext :: hexadecimal string: -hex; raw string (binary, plain) (TclByteArray): -raw; binary base64 encoded: -base64.<br />
-out raw|str|hex|base64 - type of output format for decrypted plaintext :: hexadecimal string: -hex; raw string (binary) (TclByteArray): -raw; string (TclString): -str; binary base64 encoded: -base64.<br />
<i>mcrypt_id</i> - id of MCRYPT object generated by new command (above) <br>
<i>cipher_text</i> - ciphertext you wish to decrypt.<br>
</td></tr>
<tr><td align="right">result:</td><td>return ciphet text of <i>plain_text</i></td></tr>
<tr><td align="right">example:</td><td>set ptxt [ns_mcrypt decrypt -in hex -out str $mcryptid $ctxt]</td></tr>
</table>


<h2>detach MCRYPT object</h2>
<table border="1">
<tr><td align="right">command:</td><td><tt><font color="navyblue">ns_mcrypt detach <i>mcrypt_id</i></font></tt></td></tr>
<tr><td align="right">parameters:</td><td><i>mcrypt_id</i> - id of MCRYPT object generated by new command (above)</td></tr>
<tr><td align="right">result:</td><td>detach MCRYPT object from Tcl interpreter. You can use with nsv_* for share MCRYPT object.</td></tr>
<tr><td align="right">example:</td><td>
set detachid [ns_mcrypt detach $mcryptid]<br>
nsv_set test test $detachid
</td></tr>
</table>

<h2>attach MCRYPT object</h2>
<table border="1">
<tr><td align="right">command:</td><td><tt><font color="navyblue">ns_mcrypt attach <i>detach_hash_id</i></font></tt></td></tr>
<tr><td align="right">parameters:</td><td><i>detach_hash_id</i> - detached id of MCRYPT object generated by detach command (above)</td></tr>
<tr><td align="right">result:</td><td>attach MCRYPT object to Tcl interpreter for next using. You can use with nsv_* for share MCRYPT object.</td></tr>
<tr><td align="right">example:</td><td>
set detachid [nsv_get test test]<br>
set mcryptid [ns_mcrypt attach $detachid]
</td></tr>
</table>


<h2>Full samples:</h2>
<h3>crypt plain text with base64 output cipher text and IV set as base64 string</h3>
<pre>
set td [ns_mcrypt new "rijndael-256" "cbc"]
ns_mcrypt initvector set -base64 $td "MDEyMzQ1="
ns_mcrypt init $td "foo"
set ctxt [ns_mcrypt crypt -in raw -out base64 $td "foofoo"]
ns_mcrypt flush $td 
ns_mcrypt destroy $td
ns_adp_puts $ctxt
</pre>
result: <%
set td [ns_mcrypt new "rijndael-256" "cbc"]
ns_mcrypt initvector set -base64 $td "MDEyMzQ1="
ns_mcrypt init $td "foo"
set ctxt [ns_mcrypt crypt -in raw -out base64 $td "foofoo"]
ns_mcrypt flush $td 
ns_mcrypt destroy $td
ns_adp_puts $ctxt
%>
<h3>crypt/decrypt plain text with and IV set randomly</h3>
<pre>
set td [ns_mcrypt new "rijndael-256" "cbc"]
ns_mcrypt initvector set -random $td 
ns_mcrypt init $td "foo"
set ctxt [ns_mcrypt crypt -in raw -out raw $td "foofoo"]
ns_mcrypt flush $td 
ns_mcrypt init $td "foo"
set ptxt [ns_mcrypt decrypt -in raw -out str $td $ctxt]
ns_mcrypt destroy $td
ns_adp_puts $ptxt
</pre>
result: <%
set td [ns_mcrypt new "rijndael-256" "cbc"]
ns_mcrypt initvector set -random $td 
ns_mcrypt init $td "foo"
set ctxt [ns_mcrypt crypt -in raw -out raw $td "foofoo"]
ns_mcrypt flush $td 
ns_mcrypt init $td "foo"
set ptxt [ns_mcrypt decrypt -in raw -out str $td $ctxt]
ns_mcrypt destroy $td
ns_adp_puts $ptxt
%>

<h3>crypt/decrypt plain text with and IV set as hexadecimal string and attach/detach MCRYPT object</h3>
<pre>
set td [ns_mcrypt new "rijndael-256" "ncfb"]
ns_mcrypt initvector set -hex $td "ab325897ffde"
ns_mcrypt init $td "foo"
set ctxt [ns_mcrypt crypt -in raw -out hex $td "foofoo"]
ns_mcrypt flush $td 
ns_adp_puts "cipher text (hex string): $ctxt"
set detachid [ns_mcrypt detach $td]
nsv_set test test $detachid
set id [nsv_get test test]
set td [ns_mcrypt attach $id]
ns_mcrypt init $td "foo"
set ptxt [ns_mcrypt decrypt -in hex -out raw $td $ctxt]
ns_mcrypt destroy $td
ns_adp_puts plain decrypted text: $ptxt
</pre>
result:<br /> <%
set td [ns_mcrypt new "rijndael-256" "ncfb"]
ns_mcrypt initvector set -hex $td "ab325897ffde"
ns_mcrypt init $td "foo"
set ctxt [ns_mcrypt crypt -in raw -out hex $td "foofoo"]
ns_mcrypt flush $td 
ns_adp_puts "cipher text (hex string): $ctxt <br>"
set detachid [ns_mcrypt detach $td]
nsv_set test test $detachid
set id [nsv_get test test]
set td [ns_mcrypt attach $id]
ns_mcrypt init $td "foo"
set ptxt [ns_mcrypt decrypt -in hex -out raw $td $ctxt]
ns_mcrypt destroy $td
ns_adp_puts "plain decrypted text: $ptxt"
%>

<h3>crypt/decrypt plain text with and IV set randomly</h3>
<pre>
set td [ns_mcrypt new "rijndael-256" "cfb"]
ns_mcrypt initvector set -random $td 
ns_mcrypt init $td "foo"
set ctxt ""
set buf [ns_mcrypt crypt -in raw -out hex $td "foo1"]
append ctxt $buf
set buf [ns_mcrypt crypt -in raw -out hex $td "foo2"]
append ctxt $buf
set buf [ns_mcrypt crypt -in raw -out hex $td "foo3"]
append ctxt $buf
set buf [ns_mcrypt crypt -in raw -out hex $td "foo4"]
append ctxt $buf
ns_adp_puts "cipher text (hex string): $ctxt"
ns_mcrypt flush $td 
ns_mcrypt init $td "foo"
set ptxt [ns_mcrypt decrypt -in hex -out str $td $ctxt]
ns_mcrypt destroy $td
ns_adp_puts "plain decrypted text: $ptxt"
</pre>
result: <%
set td [ns_mcrypt new "rijndael-256" "cfb"]
ns_mcrypt initvector set -random $td 
ns_mcrypt init $td "foo"
set ctxt ""
set buf [ns_mcrypt crypt -in raw -out hex $td "foo1"]
append ctxt $buf
set buf [ns_mcrypt crypt -in raw -out hex $td "foo2"]
append ctxt $buf
set buf [ns_mcrypt crypt -in raw -out hex $td "foo3"]
append ctxt $buf
set buf [ns_mcrypt crypt -in raw -out hex $td "foo4"]
append ctxt $buf
ns_adp_puts "cipher text (hex string): $ctxt <br>"
ns_mcrypt flush $td 
ns_mcrypt init $td "foo"
set ptxt [ns_mcrypt decrypt -in hex -out str $td $ctxt]
ns_mcrypt destroy $td
ns_adp_puts "plain decrypted text: $ptxt"
%>


<br>
<br>

</body>
</html>
