<html>
<head>
<title>Doc :: ns_mcrypt</title>
</head>
<body>
<h1>ns_mcrypt 1.1</h1>
<h3>Richard Kotal, <a href="mailto://info@waplikace.cz">info@waplikace.cz</a>, <a href="http://www.aolserver.cz">www.aolserver.cz</a></h3>
The module implements interface to mcrypt library (<a href="http://mcrypt.sourceforge.net">http://mcrypt.sourceforge.net</a>) for aol server and standard TCL language.
<br>
The module was tested with 2.5.7. version of mcrypt library.
<br><br>
For TCL samples see test.tcl files into docs directories.
<br><br>
PATCH:
<br>
If your aolserver crash, then we must to use patch file <em>mcrypt_extra.c.diff</em> from patch directory of ns_mcrypt.
<br>
<br>
ns_mcypt has three categories of commands:
<ul>
<li><a href="capa/index.adp">capability commands</a> - capabilities of cipher algorithms and modes (block mode, method ...)</li>
<li><a href="iv/index.adp">initializaztion vector commands</a> - manipulation with inicialization vector, ...</li>
<li><a href="crypt/index.adp">crypt/decrypt commands</a> - crypt/decrypt of strings, data, ...</li>
</ul>
<br>
Small samples:
<pre>[ns_mcrypt algorithms]</pre>
result: <%=[ns_mcrypt algorithms]%>
<br>
<br>

<pre>[ns_mcrypt capability -algo  "rijndael-256"]</pre>
result: <%=[ns_mcrypt capability -algo  "rijndael-256"]%>
<br>
<br>

<pre>
set td [ns_mcrypt new "rijndael-256" "ncfb"]
ns_mcrypt initvector set -hex $td "303132333435"
set iv [ns_mcrypt initvector get -base64 $td]
ns_adp_puts $iv
ns_mcrypt destroy $td
</pre>
result: <%
set td [ns_mcrypt new "rijndael-256" "ncfb"]
ns_mcrypt initvector set -hex $td "303132333435"
set iv [ns_mcrypt initvector get -base64 $td]
ns_adp_puts $iv
ns_mcrypt destroy $td
%>
<br>
<br>

<pre>
set td [ns_mcrypt new "rijndael-256" "cbc"]
ns_mcrypt initvector set -random $td
ns_mcrypt init $td "keyword"
set txt [ns_mcrypt crypt -in raw -out hex $td "plaintext test"]
ns_adp_puts "crypt text (hex string): $txt"
ns_mcrypt flush $td 
ns_mcrypt init $td "keyword"
set txt [ns_mcrypt decrypt -in hex -out str $td $txt]
ns_mcrypt flush $td 
ns_mcrypt destroy $td
ns_adp_puts "decrypt text: $txt"
</pre>
result:<br /> <%
set td [ns_mcrypt new "rijndael-256" "cbc"]
ns_mcrypt initvector set -random $td
ns_mcrypt init $td "keyword"
set txt [ns_mcrypt crypt -in raw -out hex $td "plaintext test"]
ns_adp_puts "crypt text (hex string): $txt"
ns_mcrypt flush $td 
ns_mcrypt init $td "keyword"
set txt [ns_mcrypt decrypt -in hex -out str $td $txt]
ns_mcrypt flush $td 
ns_mcrypt destroy $td
ns_adp_puts "<br />"
ns_adp_puts "decrypt text: $txt"
%>

</body>
</html>
